
// Licensed to the .NET Foundation under one or more agreements.
// The .NET Foundation licenses this file to you under the MIT license.

/******************************************************************

DO NOT MODIFY. AUTOGENERATED FILE.
This file is generated using the logic from <root>/src/scripts/genEventing.py

******************************************************************/
#ifndef CLR_ETW_ALL_MAIN_H
#define CLR_ETW_ALL_MAIN_H

BOOL EventEnabledGCStart_V2(void);
ULONG FireEtwGCStart_V2(
    const unsigned int  Count,
    const unsigned int  Depth,
    const unsigned int  Reason,
    const unsigned int  Type,
    const unsigned short  ClrInstanceID,
    const uint64_t  ClientSequenceNumber,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCEnd_V1(void);
ULONG FireEtwGCEnd_V1(
    const unsigned int  Count,
    const unsigned int  Depth,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCRestartEEEnd_V1(void);
ULONG FireEtwGCRestartEEEnd_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCHeapStats_V2(void);
ULONG FireEtwGCHeapStats_V2(
    const uint64_t  GenerationSize0,
    const uint64_t  TotalPromotedSize0,
    const uint64_t  GenerationSize1,
    const uint64_t  TotalPromotedSize1,
    const uint64_t  GenerationSize2,
    const uint64_t  TotalPromotedSize2,
    const uint64_t  GenerationSize3,
    const uint64_t  TotalPromotedSize3,
    const uint64_t  FinalizationPromotedSize,
    const uint64_t  FinalizationPromotedCount,
    const unsigned int  PinnedObjectCount,
    const unsigned int  SinkBlockCount,
    const unsigned int  GCHandleCount,
    const unsigned short  ClrInstanceID,
    const uint64_t  GenerationSize4,
    const uint64_t  TotalPromotedSize4,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCCreateSegment_V1(void);
ULONG FireEtwGCCreateSegment_V1(
    const uint64_t  Address,
    const uint64_t  Size,
    const unsigned int  Type,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCFreeSegment_V1(void);
ULONG FireEtwGCFreeSegment_V1(
    const uint64_t  Address,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCRestartEEBegin_V1(void);
ULONG FireEtwGCRestartEEBegin_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCSuspendEEEnd_V1(void);
ULONG FireEtwGCSuspendEEEnd_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCSuspendEEBegin_V1(void);
ULONG FireEtwGCSuspendEEBegin_V1(
    const unsigned int  Reason,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCAllocationTick_V4(void);
ULONG FireEtwGCAllocationTick_V4(
    const unsigned int  AllocationAmount,
    const unsigned int  AllocationKind,
    const unsigned short  ClrInstanceID,
    const uint64_t  AllocationAmount64,
    const void*  TypeID,
    const WCHAR*  TypeName,
    const unsigned int  HeapIndex,
    const void*  Address,
    const uint64_t  ObjectSize,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCCreateConcurrentThread_V1(void);
ULONG FireEtwGCCreateConcurrentThread_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCTerminateConcurrentThread_V1(void);
ULONG FireEtwGCTerminateConcurrentThread_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCFinalizersEnd_V1(void);
ULONG FireEtwGCFinalizersEnd_V1(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCFinalizersBegin_V1(void);
ULONG FireEtwGCFinalizersBegin_V1(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBulkType(void);
ULONG FireEtwBulkType(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkRootEdge(void);
ULONG FireEtwGCBulkRootEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkRootConditionalWeakTableElementEdge(void);
ULONG FireEtwGCBulkRootConditionalWeakTableElementEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkNode(void);
ULONG FireEtwGCBulkNode(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkEdge(void);
ULONG FireEtwGCBulkEdge(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCSampledObjectAllocationHigh(void);
ULONG FireEtwGCSampledObjectAllocationHigh(
    const void*  Address,
    const void*  TypeID,
    const unsigned int  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkSurvivingObjectRanges(void);
ULONG FireEtwGCBulkSurvivingObjectRanges(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkMovedObjectRanges(void);
ULONG FireEtwGCBulkMovedObjectRanges(
    const unsigned int  Index,
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCGenerationRange(void);
ULONG FireEtwGCGenerationRange(
    const unsigned char  Generation,
    const void*  RangeStart,
    const uint64_t  RangeUsedLength,
    const uint64_t  RangeReservedLength,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCMarkStackRoots(void);
ULONG FireEtwGCMarkStackRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCMarkFinalizeQueueRoots(void);
ULONG FireEtwGCMarkFinalizeQueueRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCMarkHandles(void);
ULONG FireEtwGCMarkHandles(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCMarkOlderGenerationRoots(void);
ULONG FireEtwGCMarkOlderGenerationRoots(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledFinalizeObject(void);
ULONG FireEtwFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledSetGCHandle(void);
ULONG FireEtwSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const unsigned int  Kind,
    const unsigned int  Generation,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledDestroyGCHandle(void);
ULONG FireEtwDestroyGCHandle(
    const void*  HandleID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCSampledObjectAllocationLow(void);
ULONG FireEtwGCSampledObjectAllocationLow(
    const void*  Address,
    const void*  TypeID,
    const unsigned int  ObjectCountForTypeSample,
    const uint64_t  TotalSizeForTypeSample,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPinObjectAtGCTime(void);
ULONG FireEtwPinObjectAtGCTime(
    const void*  HandleID,
    const void*  ObjectID,
    const uint64_t  ObjectSize,
    const WCHAR*  TypeName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCTriggered(void);
ULONG FireEtwGCTriggered(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkRootCCW(void);
ULONG FireEtwGCBulkRootCCW(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkRCW(void);
ULONG FireEtwGCBulkRCW(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCBulkRootStaticVar(void);
ULONG FireEtwGCBulkRootStaticVar(
    const unsigned int  Count,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCDynamicEvent(void);
ULONG FireEtwGCDynamicEvent(
    const WCHAR*  Name,
    const unsigned int  DataSize,
    const BYTE* Data,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadpoolSuspensionSuspendThread(void);
ULONG FireEtwThreadpoolSuspensionSuspendThread(
    const unsigned int  ClrThreadID,
    const unsigned int  CpuUtilization,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadpoolSuspensionResumeThread(void);
ULONG FireEtwThreadpoolSuspensionResumeThread(
    const unsigned int  ClrThreadID,
    const unsigned int  CpuUtilization,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadStart(void);
ULONG FireEtwThreadPoolWorkerThreadStart(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadStop(void);
ULONG FireEtwThreadPoolWorkerThreadStop(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadRetirementStart(void);
ULONG FireEtwThreadPoolWorkerThreadRetirementStart(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadRetirementStop(void);
ULONG FireEtwThreadPoolWorkerThreadRetirementStop(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentSample(void);
ULONG FireEtwThreadPoolWorkerThreadAdjustmentSample(
    const double  Throughput,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentAdjustment(void);
ULONG FireEtwThreadPoolWorkerThreadAdjustmentAdjustment(
    const double  AverageThroughput,
    const unsigned int  NewWorkerThreadCount,
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadAdjustmentStats(void);
ULONG FireEtwThreadPoolWorkerThreadAdjustmentStats(
    const double  Duration,
    const double  Throughput,
    const double  ThreadWave,
    const double  ThroughputWave,
    const double  ThroughputErrorEstimate,
    const double  AverageThroughputErrorEstimate,
    const double  ThroughputRatio,
    const double  Confidence,
    const double  NewControlSetting,
    const unsigned short  NewThreadWaveMagnitude,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkerThreadWait(void);
ULONG FireEtwThreadPoolWorkerThreadWait(
    const unsigned int  ActiveWorkerThreadCount,
    const unsigned int  RetiredWorkerThreadCount,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledYieldProcessorMeasurement(void);
ULONG FireEtwYieldProcessorMeasurement(
    const unsigned short  ClrInstanceID,
    const double  NsPerYield,
    const double  EstablishedNsPerYield,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolMinMaxThreads(void);
ULONG FireEtwThreadPoolMinMaxThreads(
    const unsigned short  MinWorkerThreads,
    const unsigned short  MaxWorkerThreads,
    const unsigned short  MinIOCompletionThreads,
    const unsigned short  MaxIOCompletionThreads,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolWorkingThreadCount(void);
ULONG FireEtwThreadPoolWorkingThreadCount(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolEnqueue(void);
ULONG FireEtwThreadPoolEnqueue(
    const void*  WorkID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolDequeue(void);
ULONG FireEtwThreadPoolDequeue(
    const void*  WorkID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolIOEnqueue(void);
ULONG FireEtwThreadPoolIOEnqueue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const BOOL  MultiDequeues,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolIODequeue(void);
ULONG FireEtwThreadPoolIODequeue(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadPoolIOPack(void);
ULONG FireEtwThreadPoolIOPack(
    const void*  NativeOverlapped,
    const void*  Overlapped,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadCreating(void);
ULONG FireEtwThreadCreating(
    const void*  ID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadRunning(void);
ULONG FireEtwThreadRunning(
    const void*  ID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionThrown_V1(void);
ULONG FireEtwExceptionThrown_V1(
    const WCHAR*  ExceptionType,
    const WCHAR*  ExceptionMessage,
    const void*  ExceptionEIP,
    const unsigned int  ExceptionHRESULT,
    const unsigned short  ExceptionFlags,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionCatchStart(void);
ULONG FireEtwExceptionCatchStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionCatchStop(void);
ULONG FireEtwExceptionCatchStop(
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionFinallyStart(void);
ULONG FireEtwExceptionFinallyStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionFinallyStop(void);
ULONG FireEtwExceptionFinallyStop(
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionFilterStart(void);
ULONG FireEtwExceptionFilterStart(
    const uint64_t  EntryEIP,
    const uint64_t  MethodID,
    const WCHAR*  MethodName,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionFilterStop(void);
ULONG FireEtwExceptionFilterStop(
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExceptionThrownStop(void);
ULONG FireEtwExceptionThrownStop(
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledContention(void);
ULONG FireEtwContention(
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledContentionStart_V2(void);
ULONG FireEtwContentionStart_V2(
    const unsigned char  ContentionFlags,
    const unsigned short  ClrInstanceID,
    const void*  LockID,
    const void*  AssociatedObjectID,
    const uint64_t  LockOwnerThreadID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledContentionStop_V1(void);
ULONG FireEtwContentionStop_V1(
    const unsigned char  ContentionFlags,
    const unsigned short  ClrInstanceID,
    const double  DurationNs,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledContentionLockCreated(void);
ULONG FireEtwContentionLockCreated(
    const void*  LockID,
    const void*  AssociatedObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledThreadCreated(void);
ULONG FireEtwThreadCreated(
    const uint64_t  ManagedThreadID,
    const uint64_t  AppDomainID,
    const unsigned int  Flags,
    const unsigned int  ManagedThreadIndex,
    const unsigned int  OSThreadID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledModuleLoad_V2(void);
ULONG FireEtwModuleLoad_V2(
    const uint64_t  ModuleID,
    const uint64_t  AssemblyID,
    const unsigned int  ModuleFlags,
    const unsigned int  Reserved1,
    const WCHAR*  ModuleILPath,
    const WCHAR*  ModuleNativePath,
    const unsigned short  ClrInstanceID,
    const GUID* ManagedPdbSignature,
    const unsigned int  ManagedPdbAge,
    const WCHAR*  ManagedPdbBuildPath,
    const GUID* NativePdbSignature,
    const unsigned int  NativePdbAge,
    const WCHAR*  NativePdbBuildPath,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledIncreaseMemoryPressure(void);
ULONG FireEtwIncreaseMemoryPressure(
    const uint64_t  BytesAllocated,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledDecreaseMemoryPressure(void);
ULONG FireEtwDecreaseMemoryPressure(
    const uint64_t  BytesFreed,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCMarkWithType(void);
ULONG FireEtwGCMarkWithType(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const unsigned int  Type,
    const uint64_t  Bytes,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCJoin_V2(void);
ULONG FireEtwGCJoin_V2(
    const unsigned int  Heap,
    const unsigned int  JoinTime,
    const unsigned int  JoinType,
    const unsigned short  ClrInstanceID,
    const unsigned int  JoinID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCPerHeapHistory_V3(void);
ULONG FireEtwGCPerHeapHistory_V3(
    const unsigned short  ClrInstanceID,
    const void*  FreeListAllocated,
    const void*  FreeListRejected,
    const void*  EndOfSegAllocated,
    const void*  CondemnedAllocated,
    const void*  PinnedAllocated,
    const void*  PinnedAllocatedAdvance,
    const unsigned int  RunningFreeListEfficiency,
    const unsigned int  CondemnReasons0,
    const unsigned int  CondemnReasons1,
    const unsigned int  CompactMechanisms,
    const unsigned int  ExpandMechanisms,
    const unsigned int  HeapIndex,
    const void*  ExtraGen0Commit,
    const unsigned int  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCGlobalHeapHistory_V4(void);
ULONG FireEtwGCGlobalHeapHistory_V4(
    const uint64_t  FinalYoungestDesired,
    const signed int  NumHeaps,
    const unsigned int  CondemnedGeneration,
    const unsigned int  Gen0ReductionCount,
    const unsigned int  Reason,
    const unsigned int  GlobalMechanisms,
    const unsigned short  ClrInstanceID,
    const unsigned int  PauseMode,
    const unsigned int  MemoryPressure,
    const unsigned int  CondemnReasons0,
    const unsigned int  CondemnReasons1,
    const unsigned int  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGenAwareBegin(void);
ULONG FireEtwGenAwareBegin(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGenAwareEnd(void);
ULONG FireEtwGenAwareEnd(
    const unsigned int  Count,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCLOHCompact(void);
ULONG FireEtwGCLOHCompact(
    const unsigned short  ClrInstanceID,
    const unsigned short  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCFitBucketInfo(void);
ULONG FireEtwGCFitBucketInfo(
    const unsigned short  ClrInstanceID,
    const unsigned short  BucketKind,
    const uint64_t  TotalSize,
    const unsigned short  Count,
    int Values_ElementSize,
    const void* Values,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledExecutionCheckpoint(void);
ULONG FireEtwExecutionCheckpoint(
    const unsigned short  ClrInstanceID,
    const WCHAR*  Name,
    const int64_t  Timestamp,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledWaitHandleWaitStart(void);
ULONG FireEtwWaitHandleWaitStart(
    const unsigned char  WaitSource,
    const void*  AssociatedObjectID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledWaitHandleWaitStop(void);
ULONG FireEtwWaitHandleWaitStop(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCDecision_V1(void);
ULONG FireEtwGCDecision_V1(
    const BOOL  DoCompact,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCSettings_V1(void);
ULONG FireEtwGCSettings_V1(
    const uint64_t  SegmentSize,
    const uint64_t  LargeObjectSegmentSize,
    const BOOL  ServerGC,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCOptimized_V1(void);
ULONG FireEtwGCOptimized_V1(
    const uint64_t  DesiredAllocation,
    const uint64_t  NewAllocation,
    const unsigned int  GenerationNumber,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCGlobalHeapHistory(void);
ULONG FireEtwGCGlobalHeapHistory(
    const uint64_t  FinalYoungestDesired,
    const signed int  NumHeaps,
    const unsigned int  CondemnedGeneration,
    const unsigned int  Gen0ReductionCount,
    const unsigned int  Reason,
    const unsigned int  GlobalMechanisms,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvGCMarkStackRoots_V1(void);
ULONG FireEtwPrvGCMarkStackRoots_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvGCMarkFinalizeQueueRoots_V1(void);
ULONG FireEtwPrvGCMarkFinalizeQueueRoots_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvGCMarkHandles_V1(void);
ULONG FireEtwPrvGCMarkHandles_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvGCMarkCards_V1(void);
ULONG FireEtwPrvGCMarkCards_V1(
    const unsigned int  HeapNum,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCBegin(void);
ULONG FireEtwBGCBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC1stNonConEnd(void);
ULONG FireEtwBGC1stNonConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC1stConEnd(void);
ULONG FireEtwBGC1stConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC2ndNonConBegin(void);
ULONG FireEtwBGC2ndNonConBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC2ndNonConEnd(void);
ULONG FireEtwBGC2ndNonConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC2ndConBegin(void);
ULONG FireEtwBGC2ndConBegin(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC2ndConEnd(void);
ULONG FireEtwBGC2ndConEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCPlanEnd(void);
ULONG FireEtwBGCPlanEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCSweepEnd(void);
ULONG FireEtwBGCSweepEnd(
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCDrainMark(void);
ULONG FireEtwBGCDrainMark(
    const uint64_t  Objects,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCRevisit(void);
ULONG FireEtwBGCRevisit(
    const uint64_t  Pages,
    const uint64_t  Objects,
    const unsigned int  IsLarge,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCOverflow_V1(void);
ULONG FireEtwBGCOverflow_V1(
    const uint64_t  Min,
    const uint64_t  Max,
    const uint64_t  Objects,
    const unsigned int  IsLarge,
    const unsigned short  ClrInstanceID,
    const unsigned int  GenNumber,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCAllocWaitBegin(void);
ULONG FireEtwBGCAllocWaitBegin(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGCAllocWaitEnd(void);
ULONG FireEtwBGCAllocWaitEnd(
    const unsigned int  Reason,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledGCFullNotify_V1(void);
ULONG FireEtwGCFullNotify_V1(
    const unsigned int  GenNumber,
    const unsigned int  IsAlloc,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledBGC1stSweepEnd(void);
ULONG FireEtwBGC1stSweepEnd(
    const unsigned int  GenNumber,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledFailFast(void);
ULONG FireEtwFailFast(
    const WCHAR*  FailFastUserMessage,
    const void*  FailedEIP,
    const unsigned int  OSExitCode,
    const unsigned int  ClrExitCode,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvFinalizeObject(void);
ULONG FireEtwPrvFinalizeObject(
    const void*  TypeID,
    const void*  ObjectID,
    const unsigned short  ClrInstanceID,
    const WCHAR*  TypeName,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvSetGCHandle(void);
ULONG FireEtwPrvSetGCHandle(
    const void*  HandleID,
    const void*  ObjectID,
    const unsigned int  Kind,
    const unsigned int  Generation,
    const uint64_t  AppDomainID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPrvDestroyGCHandle(void);
ULONG FireEtwPrvDestroyGCHandle(
    const void*  HandleID,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

BOOL EventEnabledPinPlugAtGCTime(void);
ULONG FireEtwPinPlugAtGCTime(
    const void*  PlugStart,
    const void*  PlugEnd,
    const void*  GapBeforeSize,
    const unsigned short  ClrInstanceID,
    const GUID * ActivityId = nullptr,
    const GUID * RelatedActivityId = nullptr
);

#endif // __CLR_ETW_ALL_MAIN_H__
